import getAccessTokenDispatcher from "./getAccessToken";

// test data: 6697e435d3561e6fab4a95cf, 61381e32f27ab4fbed1ec26e
export async function authSubject(request, env, ctx) {
    const headers = request.headers;
    const studyId = headers.get('x-study-id');
    const subjectId = headers.get('x-subject-id');

    if (studyId === env.TEST_STUDY_ID && subjectId === env.TEST_SUBJECT_ID)
        return true;
    if (!subjectId.match(/^[a-f0-9]{1,32}$/) || !studyId.match(/^[a-f0-9]{1,32}$/))
        return false;
    if (!(await env.EXP_SETTINGS.get('studyId', 'json')).includes(studyId))
        return false;

    return true;
}

export async function authDispatcher(request, env, ctx) {
    if (await authSubject(request, env, ctx)) {
        return await getAccessTokenDispatcher(request, env, ctx);
    } else return new Response(null, { status: 401, statusText: 'Unauthorized' });
}

export default authDispatcher;