export async function getHashString(string, method = 'SHA-256') {
	const encoder = new TextEncoder();
	const data = encoder.encode(string);
	const hash = await crypto.subtle.digest(method, data);
	const hashArray = Array.from(new Uint8Array(hash));
	return hashArray.map(b => b.toString(16).padStart(2, '0')).join('');
}

export function adaptiveFilesize(bytes, digits = 2) {
	if (bytes < 1024) return `${bytes} B`;
	else if (bytes < 1048576) return `${(bytes / 1024).toFixed(digits)} KB`;
	else return `${(bytes / 1048576).toFixed(digits)} MB`;
}